routes/web.php
<?php

use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', [\App\Http\Controllers\ArticlesController::class, 'index'])->name('dashboard');

Route::prefix('admin')->middleware(['auth', 'admin'])->name('admin.')->group(function () {
    Route::get('dashboard', [App\Http\Controllers\Admin\HomeController::class, 'index'])->name('dashboard');
    Route::get('comments', [App\Http\Controllers\Admin\CommentsController::class, 'index'])->name('comments.index');
    Route::get('comments/{comment}', [App\Http\Controllers\Admin\CommentsController::class, 'show'])->name('comments.show');
    Route::patch('comments/{comment}', [App\Http\Controllers\Admin\CommentsController::class, 'approve'])->name('comments.approve');
    Route::delete('comments/{comment}', [App\Http\Controllers\Admin\CommentsController::class, 'destroy'])->name('comments.delete');
    Route::get('users', [App\Http\Controllers\Admin\UsersController::class, 'index'])->name('users.index');
    Route::get('users/{user}', [App\Http\Controllers\Admin\UsersController::class, 'edit'])->name('users.edit');
    Route::patch('users/{user}', [App\Http\Controllers\Admin\UsersController::class, 'update'])->name('users.update');
});

Route::resource('articles', \App\Http\Controllers\ArticlesController::class)->middleware(['auth']);

Route::resource('articles.comments', \App\Http\Controllers\CommentsController::class)->only(['store', 'destroy']);

Auth::routes();

Route::get('/home', [App\Http\Controllers\HomeController::class, 'index'])->name('home');

app/Models/Article.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Relations\BelongsTo;
use Illuminate\Database\Eloquent\Relations\HasMany;

/**
 * @property int id
 * @property string title
 * @property string content
 * @property int user_id
 */
class Article extends Model
{
    use HasFactory;

    /**
     * @var string[]
     */
    protected $fillable = ['title', 'content', 'user_id'];

    /**
     * @return HasMany
     */
    public function comments(): HasMany
    {
        return $this->hasMany(Comment::class)->latest();
    }

    /**
     * @return BelongsTo
     */
    public function user(): BelongsTo
    {
        return $this->belongsTo(User::class);
    }

    /**
     * @return mixed
     */
    public function moderationComments()
    {
        return $this->comments->where('moderation', 1);
    }
}

app/Http/Controllers/ArticlesController.php
<?php

namespace App\Http\Controllers;

use App\Http\Requests\ArticleRequest;
use App\Models\Article;
use Illuminate\Auth\Access\AuthorizationException;
use Illuminate\Contracts\Foundation\Application;
use Illuminate\Contracts\View\Factory;
use Illuminate\Contracts\View\View;
use Illuminate\Http\RedirectResponse;
use Illuminate\Http\Response;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Gate;

class ArticlesController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return Application|Factory|View|Response
     */
    public function index()
    {
        $articles = Article::paginate(env('COUNT_ARTICLES_ON_PAGE', 6));
        return view('articles.index', compact('articles'));
    }

    /**
     * Display the specified resource.
     *
     * @param Article $article
     * @return Application|Factory|View|Response
     */
    public function show(Article $article)
    {
        return view('articles.show', compact('article'));
    }

    /**
     * @return Application|Factory|View
     * @throws AuthorizationException
     */
    public function create()
    {
        $this->authorize('create', Article::class);
        return view('articles.create');
    }

    /**
     * @param ArticleRequest $request
     * @return RedirectResponse
     * @throws AuthorizationException
     */
    public function store(ArticleRequest $request): RedirectResponse
    {
        $this->authorize('create', Article::class);
        $article = new Article();
        $article->title = $request->input('title');
        $article->content = $request->input('content');
        $article->user_id = $request->user()->id;

        // Либо
        //$article->user()->associate($request->user());
        $article->save();
        return redirect()->route('articles.index');
    }


    /**
     * @param Article $article
     * @return Application|Factory|View
     * @throws AuthorizationException
     */
    public function edit(Article $article)
    {
        $this->authorize('edit', $article);
        return view('articles.edit', compact('article'));
    }

    /**
     * Update the given blog article.
     *
     * @param ArticleRequest $request
     * @param Article $article
     * @return RedirectResponse
     * @throws AuthorizationException
     */
    public function update(ArticleRequest $request, Article $article): RedirectResponse
    {
        $this->authorize('update', $article);
        $article->update($request->all());
        return redirect()->route('articles.index');
    }

    /**
     * @param Article $article
     * @return RedirectResponse
     * @throws AuthorizationException
     */
    public function destroy(Article $article): RedirectResponse
    {
        $this->authorize('delete', $article);
        $article->delete();
        return redirect()->route('articles.index');
    }
}

resources/views/articles/create.blade.php
@extends('layouts.app')

@section('content')
    <div class="col-12">

        <h1>Create new Article</h1>
    </div>
    <div class="col-12">
        <form method="post" action="{{route('articles.store')}}">
            @csrf
            <div class="form-group">
                <label for="article-title">Title</label>
                <input name="title" type="text" class="form-control" id="article-title">
            </div>
            <div class="form-group">
                <label for="exampleInputPassword1">Content</label>
                <textarea name="content" class="form-control" id="exampleInputPassword1"></textarea>
            </div>
            <button type="submit" class="btn btn-primary">Create article</button>
        </form>
    </div>
    <div style="padding-top: 25px" class="col-2">
        <a href="{{route('articles.index')}}" class="btn btn-primary btn-sm active" role="button"
           aria-pressed="true">Back</a>
    </div>
@endsection

resources/views/articles/edit.blade.php
@extends('layouts.app')

@section('content')
    <div class="row">
        <div class="col">
            <h1>Edit article</h1>
        </div>
    </div>
    <div class="row">
        <div class="col">
            <form method="post" action="{{route('articles.update', ['article' => $article])}}">
                @csrf
                @method('put')
                <div class="form-group">
                    <label for="article-title">Title</label>
                    <input name="title" type="text" class="form-control" id="article-title" value="{{$article->title}}">
                </div>
                <div class="form-group">
                    <label for="exampleInputPassword1">Content</label>
                    <textarea rows="3" name="content" class="form-control" id="exampleInputPassword1">{{$article->content}}</textarea>
                </div>
                <button type="submit" class="btn btn-primary">Update article</button>
            </form>
        </div>
    </div>
    <div class="row">
        <div style="padding-top: 25px" class="col-2">
            <a href="{{route('articles.index')}}" class="btn btn-primary btn-sm active" role="button"
               aria-pressed="true">Back</a>
        </div>
    </div>

@endsection

resources/views/articles/index.blade.php
@extends('layouts.app')
@section('content')
    <div class="row">
        <div class="col">
            <h3>Articles
                @can('create', \App\Models\Article::class)
                <a href="{{route('articles.create')}}" class="btn btn-primary btn-sm active" role="button"
                   aria-pressed="true">Create new Article</a>
                @endcan
            </h3>
        </div>
    </div>
    <div class="row">
        @foreach($articles as $article)
            <div class="col" style="padding: 35px 0 0 0;">
                <div class="card" style="width: 18rem;">
                    <div class="card-header">
                        {{ $article->title }}
                        <span class="badge badge-info" style="cursor: pointer" title="Comments count">
                            {{$article->moderationComments()->count()}}
                        </span>
                        @can('edit', $article)
                            <span class="edit-article" title="Edit {{$article->title}}">
                                <a href="{{route('articles.edit', ['article' => $article])}}" class="bi bi-pencil"></a>
                            </span>
                        @endcan
                        @can('delete', $article)
                        <form action="{{route('articles.destroy', compact('article'))}}" method="post">
                            @csrf
                            @method('delete')
                            <button type="submit" class="btn btn-sm btn-outline-danger">Delete article</button>
                        </form>
                        @endcan
                    </div>
                    <div class="card-body">
                        <blockquote class="blockquote mb-0">
                            <p class="text-truncate">
                                {{ $article->content }}
                            </p>
                        </blockquote>
                        <a href="{{route('articles.show', ['article' => $article])}}" class="card-link">Show more
                            ...</a>
                    </div>
                </div>
            </div>
        @endforeach
    </div>
    <div class="row justify-content-md-center p-3">
        <div class="col col-lg-3">
            {{$articles->links('pagination::bootstrap-4')}}
        </div>
    </div>
@endsection

resources/views/articles/show.blade.php
@extends('layouts.app')
@section('content')
    <div class="row">
        <div class="col">
            <div class="modal fade" id="exampleModalCenter" tabindex="-1" role="dialog" aria-labelledby="exampleModalCenterTitle" aria-hidden="true">
                <div class="modal-dialog modal-dialog-centered" role="document">
                    <div class="modal-content">
                        <div class="modal-header">
                            <h5 class="modal-title" id="exampleModalLongTitle">Attention</h5>
                            <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                                <span aria-hidden="true">&times;</span>
                            </button>
                        </div>
                        <div class="modal-body" id="attention-modal-body">

                        </div>
                        <div class="modal-footer">
                            <button type="button" class="btn btn-sm btn-secondary" data-dismiss="modal">Close</button>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
    <div class="row">
        <div class="col">
            <h3 class="article-title">
                {{$article->title}}
                <form style="display: inline-block;" action="{{route('articles.destroy', compact('article'))}}" method="post">
                    @csrf
                    @method('delete')
                    <button type="submit" class="btn btn-sm btn-outline-danger">Remove article</button>
                </form> | <a class="btn btn-sm btn-outline-primary" href="{{route('articles.edit', compact('article'))}}">Edit article</a>
            </h3>
            <blockquote class="blockquote">
                <p class="mb-2" style="text-align: justify">
                    {{$article->content}}
                </p>
                <footer class="blockquote-footer">
                    Author: {{$article->user->name}}, created in
                    <cite title="Created at article">
                        {{$article->created_at->diffForHumans()}}
                    </cite>
                </footer>
            </blockquote>
        </div>
    </div>
    <div class="row">
        <div class="col-md-12">
            <h3>
                Comments
                <button type="button" class="btn btn-sm btn-primary" data-toggle="modal"
                        data-target="#exampleModalScrollable">
                    Add comment
                </button>
            </h3>
        </div>
    </div>
    <div class="modal fade" id="exampleModalScrollable" tabindex="-1" role="dialog"
         aria-labelledby="exampleModalScrollableTitle" aria-hidden="true">
        <div class="modal-dialog modal-dialog-centered" role="document">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title" id="exampleModalScrollableTitle">Create new comment</h5>
                    <button type="button" class="close close-create-comment-modal" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                <div class="modal-body">
                    <div class="comment-form">
                        <form id="create-comment">
                            @csrf
                            <input type="hidden" id="article_id" value="{{$article->id}}">
                            <div class="form-group">
                                <label for="bodyId">Comment</label>
                                <textarea id="bodyId" name="body" class="form-control" rows="3"
                                          required></textarea>
                            </div>
                        </form>
                    </div>
                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-secondary close-create-comment-modal" data-dismiss="modal">Close</button>
                    <button type="button" id="create-comment-btn" class="btn btn-primary">Comment</button>
                </div>
            </div>
        </div>
    </div>
    <div class="row">
        <div class="col scrollit">
            @foreach($article->moderationComments() as $comment)
                <div id="comment-{{$comment->id}}" class="">
                    <div class="media g-mb-30 media-comment">
                        <img class="d-flex g-width-50 g-height-50 rounded-circle g-mt-3 g-mr-15"
                             src="{{asset('default_avatar.png')}}" alt="Image Description">
                        <div class="media-body u-shadow-v18 g-bg-secondary g-pa-30">
                            <div class="g-mb-15">
                                <h5 class="h5 g-color-gray-dark-v1 mb-0">{{$comment->user->name}}</h5>
                                <span id="delete-comment-{{$comment->id}}" class="delete-comment" data-comment-id="{{$comment->id}}">
                                    <input type="hidden" id="csrf-{{$comment->id}}" value="{{csrf_token()}}">
                                    <i class="bi bi-trash-fill"></i>
                                </span>
                                <span
                                    class="g-color-gray-dark-v4 g-font-size-12">{{$comment->created_at->diffForHumans()}}</span>
                            </div>
                            <p>
                                {{$comment->body}}
                            </p>
                        </div>
                    </div>
                </div>
            @endforeach
        </div>
    </div>
@endsection